# dnnc-operators
Development and discussion of DNNC operators.  

* Our work is based on **[ONNX operator release 1.5.0](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md)** till now.

* To get started on development, see this **[Developer's getting started guide](https://github.com/ai-techsystems/dnnc-operators/blob/master/docs/DeveloperGettingStartedGuide.md)**.  

* To get an idea of how to implement numpy like interface with dnnc see **[dnnc Tensor Functions](docs/dnncTensorFunctions.md)**.  

* To see how to implement dnnc python interface see this **[Implementation guide](https://github.com/ai-techsystems/dnnc-operators/blob/master/test/README.md)**

* To see why we are using Eigen library check this: **[Why should we use Eigen](https://github.com/ai-techsystems/dnnc-operators/blob/master/docs/benefitsOfUsingEigenInElementWiseOperations.md)**

* To refer back to the original Readme **[click here](https://github.com/ai-techsystems/dnnCompiler/blob/master/README.md)**.  


#### Below is the list of current ongoing operators list (Under Construction)


---

| Operator              	      																			|		Doxygen			|      Testcases     	| Dimensions required 	| Dimensions supported 	| Broadcasting required 	| Broadcasting supported 	|  Completion status 	| Contributer 	|
|:--------------------------------------------------------------------------------------------------------: |:---------------------:|:------------------:	|:-------------------:	|:--------------------:	|:---------------------:	|:----------------------:	|:------------------:	|:-----------:	|
| [Abs](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Abs)                   					|						|   				    |         N D         	|          N D         	|          :x:          	|           :x:          	| :heavy_check_mark: 	|    Hrishikesh   	|
| [Acos](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Acos)                  					|						|   				    |         N D         	|          N D         	|          :x:          	|           :x:          	| :heavy_check_mark: 	|    Hrishikesh   	|
| [Acosh](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Acosh)                 				|						|   				    |         N D         	|          N D         	|          :x:          	|           :x:          	| :heavy_check_mark: 	|    Hrishikesh   	|
| [Add](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Add)                   					|   :heavy_check_mark:  |   :heavy_check_mark:  |         N D         	|          N D         	|   :heavy_check_mark:  	|   :heavy_check_mark:  	|   :heavy_check_mark:  |    Rohit   	|
| [And](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#And)                   					|   :heavy_check_mark:  |   :heavy_check_mark:  |         N D         	|          N D         	|   :heavy_check_mark:  	|   :heavy_check_mark:  	|   :heavy_check_mark:  |    Gunjan   	|
| [ArgMax](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ArgMax)                				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [ArgMin](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ArgMin)                				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Asin](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Asin)                  					|						|   				    |         N D         	|          N D         	|          :x:          	|           :x:          	| :heavy_check_mark: 	|    Hrishikesh   	|
| [Asinh](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Asinh)                 				|						|   				    |         N D         	|          N D         	|          :x:          	|           :x:          	| :heavy_check_mark: 	|    Hrishikesh   	|
| [Atan](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Atan)                  					|						|   				    |         N D         	|          N D         	|          :x:          	|           :x:          	| :heavy_check_mark: 	|    Hrishikesh   	|
| [Atanh](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Atanh)                 				|						|   				    |         N D         	|          N D         	|          :x:          	|           :x:          	| :heavy_check_mark: 	|    Hrishikesh   	|
| [AveragePool](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#AveragePool)           			|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [BatchNormalization](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#BatchNormalization)   	|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [BitShift](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#BitShift)              				|   :heavy_check_mark:  |   :heavy_check_mark:  |         N D         	|          N D         	|   :heavy_check_mark:  	|   :heavy_check_mark:  	|   :heavy_check_mark:  |    Gunjan   	|
| [Cast](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Cast)                  					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Ceil](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Ceil)                  					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Clip](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Clip)                  					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Compress](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Compress)              				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Concat](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Concat)                				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Constant](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Constant)              				|						|                    	|         N D         	|       N D            	|          :x:          	|        :x:             	|   :heavy_check_mark:  |  Rohit      	|
| [ConstantOfShape](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ConstantOfShape)      		|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Conv](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Conv)  |                       |   :heavy_check_mark:  |         N D         	|          N D         	|                       	|                       	|   :heavy_check_mark:  |    Rohit   	|
| [ConvInteger](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ConvInteger)        				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [ConvTranspose](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ConvTranspose)        			|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Cos](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Cos)                   					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Cosh](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Cosh)                  					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [CumSum](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#CumSum)                				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [DepthToSpace](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#DepthToSpace)          			|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [DequantizeLinear](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#DequantizeLinear)     		|   :heavy_check_mark:  |   :heavy_check_mark:  |         N D         	|          N D         	|          :x:          	|           :x:          	|   :heavy_check_mark:  |	 Gunjan		|
| [Div](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Div)                   					|   :heavy_check_mark:  |   :heavy_check_mark:  |         N D         	|          N D         	|   :heavy_check_mark:  	|   :heavy_check_mark:  	|   :heavy_check_mark:  |    Gunjan   	|
| [Dropout](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Dropout)               				|   :heavy_check_mark:  |   :heavy_check_mark:  |         N D         	|          N D         	|          :x:          	|           :x:          	|   :heavy_check_mark:  |	 Gunjan		|
| [Elu](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Elu)                   					|   :heavy_check_mark:  |   :heavy_check_mark:  |         1 D         	|          1 D         	|          :x:          	|           :x:          	|   :heavy_check_mark: 	|    Gunjan   	|
| [Equal](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Equal)                 					|   :heavy_check_mark:  |   :heavy_check_mark:  |        N D         	|          N D         	|   :heavy_check_mark:  	|   :heavy_check_mark:  	|   :heavy_check_mark:  |    Gunjan   	|
| [Erf](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Erf)                   					|   :heavy_check_mark:  |   :heavy_check_mark:  |         N D         	|          N D         	|          :x:          	|           :x:          	|   :heavy_check_mark: 	|    Gunjan   	|
| [Exp](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Exp)                   					|   :heavy_check_mark:  |   :heavy_check_mark:  |         N D         	|          N D         	|          :x:          	|           :x:          	|   :heavy_check_mark: 	|    Gunjan   	|
| [Expand](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Expand)                				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [EyeLike](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#EyeLike)               				|   :heavy_check_mark:  |   :heavy_check_mark:  |         2 D         	|          2 D         	|          :x:          	|           :x:          	|   DataType required 	|    Gunjan   	|
| [Flatten](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Flatten)               				|   :heavy_check_mark:  |   :heavy_check_mark:  |         N D         	|          N D         	|          :x:          	|           :x:          	|   :heavy_check_mark: 	|    Gunjan   	|
| [Floor](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Floor)                 					|   :heavy_check_mark:  |   :heavy_check_mark:  |         N D         	|          N D         	|          :x:          	|           :x:          	|   :heavy_check_mark: 	|    Gunjan   	|
| [GRU](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#GRU)                   					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Gather](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Gather)                				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [GatherElements](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#GatherElements)        		|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Gemm](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Gemm)                  					|   :heavy_check_mark:  |   :heavy_check_mark: 	|         2 D         	|          2 D         	|   :heavy_check_mark:  	|           :x:          	|   :heavy_check_mark: 	|	 Gunjan 	|
| [GlobalAveragePool](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#GlobalAveragePool)			|   :heavy_check_mark:  |:heavy_check_mark: 					    |         N D           |          N D          |          :x:            	|           :x:           	| :heavy_check_mark:   	| Nalin Shani  	|
| [GlobalLpPool](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#GlobalLpPool)					|   :heavy_check_mark:  |:heavy_check_mark: |         N D            	|        N D  |   :x:  |     :x:  |    :heavy_check_mark:          	|  Nalin Shani           	|
| [GlobalMaxPool](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#GlobalMaxPool)         			|   :heavy_check_mark:  |:heavy_check_mark:		                   	|         N D            	|          N D    |         :x:      |     :x:   |     :heavy_check_mark:               	|  Nalin Shani           	|
| [Greater](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Greater)        		                |   :heavy_check_mark:  | 		:heavy_check_mark:	|      N D               	|           N D           	|       :heavy_check_mark:|   :heavy_check_mark:|      :heavy_check_mark:| Nalin Shani            	|
| [HardSigmoid](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#HardSigmoid)      				|   :heavy_check_mark:  |:heavy_check_mark:   	|      N D               	|           N D           	|               :x:  |   :x:  |      :heavy_check_mark:              	| Nalin Shani  	|
| [HardMax](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#HardMax)                              |   :heavy_check_mark:  | :heavy_check_mark:   	|          N D           	|         N D             	|          :x: 	|       :x:|:heavy_check_mark:	| Nalin Shani            	|
| [Identity](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Identity)   							|   :heavy_check_mark:  |	 :heavy_check_mark:	|           N D          	|         N D             	|   :x:  	|        :x: 	|     :heavy_check_mark: 	|  Nalin Shani           	|
| [If](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#If)                    					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [InstanceNormalization](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#InstanceNormalization)  |   :heavy_check_mark:  |:heavy_check_mark:    	|      N D               	|          N D            	|   :x:                    	|                   :x:     	|         :heavy_check_mark:           	|      Nalin Shani       	|
| [IsInf](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#IsInf)                 					|   :heavy_check_mark:  |:heavy_check_mark:|      N D               	|         N D             	|     :x:| :x:    	|:heavy_check_mark:     	| Nalin Shani            	|
| [IsNaN](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#IsNaN)                 					|   :heavy_check_mark:  |:heavy_check_mark:|    N D                 	|         N D             	|         :x:	|       :x: |    :heavy_check_mark:                	|  Nalin Shani  	|
| [LRN](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#LRN)                   					|	:heavy_check_mark:	| :heavy_check_mark:    	|      N D              	|       N D              	|     :x:           	|           :x:             	|          :heavy_check_mark:          	|  Nalin Shani           	|
| [LSTM](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#LSTM)                  					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [LeakyRelu](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#LeakyRelu)             				|   :heavy_check_mark:  |:heavy_check_mark:     |      N D             	|           N D           	|      :x:   |   :x:	|  :heavy_check_mark:           	| Nalin Shani            	|
| [Less](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Less)                  					|	:heavy_check_mark:	|:heavy_check_mark:     |      N D              |       N D             |  :heavy_check_mark:       |        :heavy_check_mark: |  :heavy_check_mark:    |    Nikhil    
| [Log](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Log)                   					|	:heavy_check_mark:	| :heavy_check_mark:  	|      N D              |       N D             |  :x:                      |   :x:                     |    :heavy_check_mark:  |    Nikhil    |
| [LogSoftmax](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#LogSoftmax)            			|	:heavy_check_mark:	| :heavy_check_mark:    |      N D              |      N D              |  :x:                      |   :x:                     |    :heavy_check_mark:  |    Nikhil    |
| [Loop](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Loop)                  					|						|                    	|                     	|                       |                       	|                        	|                    	 |             	|
| [LpNormalization](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#LpNormalization)    			|:heavy_check_mark:	    | :heavy_check_mark:    |      2 D              |       2 D             |   :x:                     |   :x:                     |    :heavy_check_mark:  |    Nikhil    |
| [LpPool](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#LpPool)                				|						|                    	|                     	|                      	|                       	|                        	|                    	 |             	|
| [MatMul](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#MatMul)                				|						| 	4 D doesn't work	|         N D         	|          4 D         	|          :x:          	|           :x:          	| :heavy_check_mark: 	 |    Rohit    	|
| [MatMulInteger](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#MatMulInteger)    				|:heavy_check_mark:		|  4 D doesn't work     |        N D            |        3 D            |         :x:           	|   :x:                     | :heavy_check_mark:     |    Nikhil    |
| [Max](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Max)                   					|:heavy_check_mark:		|  :heavy_check_mark:   |        N D            |          N D          |   :heavy_check_mark:      |   :heavy_check_mark:      |:heavy_check_mark:      |    Nikhil    |
| [MaxPool](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#MaxPool)               				|						|                    	|                     	|                      	|                       	|                        	|                    	 |             	|
| [MaxRoiPool](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#MaxRoiPool)            			|						|                    	|                     	|                      	|                       	|                        	|                    	 |             	|
| [MaxUnpool](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#MaxUnpool)             				|						|                    	|                     	|                      	|                       	|                        	|                    	 |             	|
| [Mean](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Mean)                  					|:heavy_check_mark:		|   :heavy_check_mark:  |      N D              |          N D          |    :heavy_check_mark:     |  :heavy_check_mark:       |   :heavy_check_mark:   |    Nikhil    |
| [Min](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Min)                   					|:heavy_check_mark:	    |   :heavy_check_mark:  |      N D              |          N D          |   :heavy_check_mark:      |:heavy_check_mark:         |   :heavy_check_mark:   |    Nikhil    |
| [Mod](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Mod)                   					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Mul](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Mul)                   					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Multinomial](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Multinomial)           			|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Neg](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Neg)                   					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [NonMaxSupression](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#NonMaxSupression)      		|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [NonZero](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#NonZero)               				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Not](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Not)                   					|   :heavy_check_mark:  |   :heavy_check_mark:  |         N D         	|          N D         	|   		:x: 		 	|           :x:          	| 	:heavy_check_mark: 	|    Gunjan   	|
| [OneHot](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#OneHot)                				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Or](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Or)                    					|   :heavy_check_mark:  |   :heavy_check_mark:  |         N D         	|          N D         	|   :heavy_check_mark:  	|   :heavy_check_mark:  	|   :heavy_check_mark:  |    Gunjan   	|
| [PRelu](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#PRelu)                 					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Pad](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Pad)                   					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Pow](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Pow)                   					|   :heavy_check_mark:  |   :heavy_check_mark:  |         N D         	|          N D         	|   :heavy_check_mark:  	|   :heavy_check_mark:  	|   :heavy_check_mark:  |    Gunjan   	|
| [QLinearConv](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#QLinearConv)           			|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [QlinearMatMul](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#QlinearMatMul)        			|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [QuantizeLinear](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#QuantizeLinear)       			|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [RNN](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#RNN)                   					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [RandomNormal](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#RandomNormal)          			|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [RandomNormalLike](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#RandomNormalLike)      		|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [RandomUniform](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#RandomUniform)         			|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [RandomUniformLike](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#RandomUniformLike)    		|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Reciprocal](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Reciprocal)            			|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [ReduceL1](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ReduceL1)              				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [ReduceL2](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ReduceL2)              				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [ReduceLogSum](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ReduceLogSum)          			|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [ReduceLogSumExp](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ReduceLogSumExp)       		|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [ReduceMax](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ReduceMax)             				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [ReduceMean](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ReduceMean)            			|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [ReduceMin](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ReduceMin)             				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [ReduceProd](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ReduceProd)            			|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [ReduceSum](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ReduceSum)             				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [ReduceSumSquare](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ReduceSumSquare)       		|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Relu](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Relu)                  					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Reshape](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Reshape)              				|						|                    	|         N D         	|       N D            	|          :x:          	|        :x:             	|   :heavy_check_mark:  |  Rohit      	|
| [Resize](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Resize)                				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [ReverseSequence](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ReverseSequence)       		|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [RoiAlign](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#RoiAlign)              				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Round](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Round)                 					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Scan](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Scan)                  					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Scatter](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Scatter)               				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [ScatterElements](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ScatterElements)       		|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Selu](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Selu)                  					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Shape](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Shape)                 					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Shrink](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Shrink)                				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Sigmoid](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Sigmoid)               				|						|                    	|                     N D |    3 D                  	|                       	|                        	|             :heavy_check_mark:       	|  Subham           	|
| [Sign](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Sign)                  					|						|                    	|                     N D 	|   3 D                   	|                       	|                        	|            :heavy_check_mark:        	|  Subham           	|
| [Sin](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Sin)                   					|						|                    	|                     N D 	|   3 D                   	|                       	|                        	|            :heavy_check_mark:        	|  Subham           	|
| [Sinh](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Sinh)                  					|						|                    	|                     N D 	|   3 D                   	|                       	|                        	|               :heavy_check_mark:     	|  Subham           	|
| [Size](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Size)                  					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Slice](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Slice)                 					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Softmax](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Softmax)               				|						|                    	|                     2 D 	|    N D                   	|                       	|                        	|             :heavy_check_mark:       	| Subham          	|
| [Softplus](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Softplus)              				|						|                    	|                     N D	|   3 D                    	|                       	|                        	|            :heavy_check_mark:        	| Subham          	|
| [Softsign](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Softsign)              				|						|                    	|                     N D 	|  3 D                    	|                       	|                        	|           :heavy_check_mark:         	| Subham         	|
| [SpaceToDepth](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#SpaceToDepth)          			|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Split](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Split)                 					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Sqrt](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Sqrt)                  					|						|                    	|                     N D	|   3 D                   	|                       	|                        	|             :heavy_check_mark:       	| Subham           	|
| [Squeeze](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Squeeze)               				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [StringNormalizer](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#StringNormalizer)    		|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Sub](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Sub)                   					|						| 					    |         N D          	|          4 D         	|          :x:          	|                       	| :heavy_check_mark: 	|    Vishal    	|
| [Sum](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Sum)                   					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Tan](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Tan)                   					|						| 					   	|         N D         	|          3 D         	|          :x:          	|                        	| :heavy_check_mark: 	|    Vishal   	|
| [Tanh](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Tanh)                  					|						| 					 	|         N D         	|          3 D         	|          :x:          	|                        	| :heavy_check_mark: 	|    Vishal    	|
| [TfIdfVectorizer](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#TfIdfVectorizer)       		|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [ThresholdedRelu](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#ThresholdedRelu)       		|						| 					 	|         N D         	|          N D         	|          :x:          	|           :x:          	| :heavy_check_mark: 	|    Rohit    	|
| [Tile](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Tile)                  					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [TopK](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#TopK)                  					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Transpose](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Transpose)             				|						| 					  	|         N D         	|          3 D         	|                       	|                        	| :heavy_check_mark: 	|    Vishal    	|
| [Unique](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Unique)                				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Unsqueeze](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Unsqueeze)              			|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Upsample](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Upsample)              				|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Where](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Where)                 					|						|                    	|                     	|                      	|                       	|                        	|                    	|             	|
| [Xor](https://github.com/onnx/onnx/blob/rel-1.5.0/docs/Operators.md#Xor)                   					|   :heavy_check_mark:  |   :heavy_check_mark:  |         N D         	|          N D         	|   :heavy_check_mark:  	|   :heavy_check_mark:  	|   :heavy_check_mark:  |    Gunjan   	|
